import { LRParser } from '@lezer/lr';
import { LRLanguage, indentNodeProp, foldNodeProp, foldInside, LanguageSupport } from '@codemirror/language';
import { styleTags, tags } from '@lezer/highlight';

// This file was generated by lezer-generator. You probably shouldn't edit it.
const parser = LRParser.deserialize({
  version: 14,
  states: "!WQYQPOOOhQPO'#CdOOQO'#Ci'#CiOOQO'#Ce'#CeQYQPOOOOQO,59O,59OOyQPO,59OOOQO-E6c-E6cOOQO1G.j1G.j",
  stateData: "![~O[OSPOS~ORQOSQOTQOVPO~ORQOSQOTQOUTOVPO~ORQOSQOTQOUWOVPO~O",
  goto: "u^PPPPPPPP_ePPPoXQOPSUQSOQUPTVSUXROPSU",
  nodeNames: "⚠ LineComment Program Identifier String Boolean ) ( Application",
  maxTerm: 13,
  nodeProps: [
    ["openedBy", 6,"("],
    ["closedBy", 7,")"]
  ],
  skippedNodes: [0,1],
  repeatNodeCount: 1,
  tokenData: "&}~RYXYqYZq]^qpqqrs!Sst#pxy$Oyz$T!]!^$Y#o#p$q~vS[~XYqYZq]^qpqq~!VVOr!Srs!ls#O!S#O#P!q#P;'S!S;'S;=`#j<%lO!S~!qOS~~!tRO;'S!S;'S;=`!};=`O!S~#QWOr!Srs!ls#O!S#O#P!q#P;'S!S;'S;=`#j;=`<%l!S<%lO!S~#mP;=`<%l!S~#sQ#Y#Z#y#h#i#y~$OOT~~$TOV~~$YOU~~$_SP~OY$YZ;'S$Y;'S;=`$k<%lO$Y~$nP;=`<%l$Y~$tWOr$qs#O$q#O#P%^#P#q$q#q#r&Y#r;'S$q;'S;=`&w<%lO$q~%aRO;'S$q;'S;=`%j;=`O$q~%mXOr$qs#O$q#O#P%^#P#q$q#q#r&Y#r;'S$q;'S;=`&w;=`<%l$q<%lO$q~&_WR~Or$qs#O$q#O#P%^#P#q$q#q#r&Y#r;'S$q;'S;=`&w<%lO$q~&zP;=`<%l$q",
  tokenizers: [0],
  topRules: {"Program":[0,2]},
  tokenPrec: 0
});

const NuformulaLanguage = LRLanguage.define({
    parser: parser.configure({
        props: [
            indentNodeProp.add({
                Application: context => context.column(context.node.from) + context.unit
            }),
            foldNodeProp.add({
                Application: foldInside,
            }),
            styleTags({
                Identifier: tags.variableName,
                Boolean: tags.bool,
                String: tags.string,
                LineComment: tags.lineComment,
                "( )": tags.paren,
            }),
        ],
    }),
    languageData: {
        commentTokens: { line: ";" },
    },
});
function nuformula() {
    return new LanguageSupport(NuformulaLanguage);
}

export { NuformulaLanguage, nuformula };
